#!/usr/bin/env python

#Quick Terminal v.0.1 

import sys, gtk, vte, subprocess
#Needs at least python-gtk2 and python-vte installed (a must have)

class Quickterm(gtk.Window):

#Toolbar2 functions

    def copy(self, widget):
        self.vte.copy_clipboard()
        self.vte.grab_focus()

    def paste(self, widget):
        self.vte.paste_clipboard()
        self.vte.grab_focus()
        
    def clear_terminal(self,widget):
        self.vte.feed_child("clear")       
        
    def clear_history(self,widget):
        self.vte.feed_child("history -c")       
		
#About dialog function
    def about1 (self, widget):
        about1 = gtk.AboutDialog()
        about1.set_program_name("Quick Terminal ")
        about1.set_version("V.0.1")
        about1.set_copyright(" Copyright (c) 2016 JJ Posti <techtimejourney.net>")
        about1.set_comments("Quick terminal is a terminal emulator written with Python. The program comes with ABSOLUTELY NO WARRANTY; for details see: http://www.gnu.org/copyleft/gpl.html. This is free software, and you are welcome to redistribute it under GPL Version 2, June 1991.")
        about1.set_website("www.techtimejourney.net")
        about1.run()
        about1.destroy()
 
###########	
#Make the window
###########	
    def __init__(self):    
    # Create THE WINDOW
        self.window1 = gtk.Window(gtk.WINDOW_TOPLEVEL)        
        self.window1.set_title("Quick Terminal")
#Toolbars
        self.toolbar=gtk.Toolbar()
        self.toolbar2=gtk.Toolbar()

#Create menubar
        self.bar=gtk.MenuBar()
#################################
###MENUS
###############

###FILE MENU
    #Create menu items for File menu

        self.file_menu=gtk.Menu()
        self.filemenu=gtk.MenuItem("File")
        self.filemenu.set_submenu(self.file_menu)
 
#Buttons for File menu

#Close button for file menu

        self.away=gtk.MenuItem("Close")
        self.away.connect("activate", gtk.main_quit)

#About button for file menu

        self.about=gtk.MenuItem("About")
        self.about.connect("activate", self.about1)
        
#Appending things to File_menu        
        self.file_menu.append(self.about)
        self.file_menu.append(self.away)

#Appending things to Menubar
        self.bar.append(self.filemenu)
        	

#Toolbar2 buttons
        
        self.COPY_button=gtk.ToolButton(gtk.STOCK_COPY)
        self.COPY_button.set_label("Copy")
        self.COPY_button.connect("clicked", self.copy)               
        self.toolbar2.insert(self.COPY_button, -1)
        
        self.PASTE_button=gtk.ToolButton(gtk.STOCK_PASTE)
        self.PASTE_button.set_label("Paste")
        self.PASTE_button.connect("clicked", self.paste)               
        self.toolbar2.insert(self.PASTE_button, -1)
             
        self.CLEAR_button=gtk.ToolButton(gtk.STOCK_CLOSE)
        self.CLEAR_button.set_label("Clear Terminal")
        self.CLEAR_button.connect("clicked", self.clear_terminal)               
        self.toolbar2.insert(self.CLEAR_button, -1)  
        
        self.CLEAR2_button=gtk.ToolButton(gtk.STOCK_CLEAR)
        self.CLEAR2_button.set_label("Clear History")
        self.CLEAR2_button.connect("clicked", self.clear_history)               
        self.toolbar2.insert(self.CLEAR2_button, -1)               


#Terminal
        self.vte = vte.Terminal()
        self.vte.connect ("child-exited", lambda term: gtk.main_quit())

#fork_command
        self.vte.fork_command()

#Scrolled window
        self.scroll=gtk.ScrolledWindow()
        self.scroll.set_policy(gtk.POLICY_NEVER,
                               gtk.POLICY_AUTOMATIC)
        self.scroll.set_usize(650, 450)
        self.scroll.add(self.vte)


#Vertical box/buttons container
        self.vbox=gtk.VBox(False)

        self.vbox.pack_start(self.bar, False, False, 1)
        self.vbox.pack_start(self.toolbar2, False, False, 2)
        self.vbox.pack_start(self.scroll, True, True, 2)

#Show everything		
        self.window1.add(self.vbox)
        self.window1.show_all()
         
#Making window resizable and enabling the close window connector        
        self.window1.set_resizable(True)
        self.window1.connect('delete-event', lambda window, event: gtk.main_quit())

def main():
    gtk.main()
    return 0

if __name__ == "__main__":
    Quickterm()
    main()




